/* WorkPlaceCalendar v0.4 */

/* week start setup --------------------------*/

weekstart=0 /* 0 = Monday; 1 = Sunday */

/* -------------------------------------------*/

parse source . . ScriptFile
inst_drive = filespec("D", ScriptFile)
inst_path = filespec("P", scriptfile)
installpath=inst_drive||inst_path
iconpath=inst_drive||inst_path||'ICONS\'
language = left(Value('Lang',,'OS2ENVIRONMENT'),2)

cur_date = date('S')

if rxfuncquery('SysLoadFuncs') then do
 call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
 call SysLoadFuncs
end

object_id = "<WP_Calendar>"
objecttext = BuildCalendar(cur_date)
parse var objecttext Day ' ' objecttext

if DayOfWeek(substr(cur_date, 7,2)||'.'substr(cur_date, 5,2)||'.'substr(cur_date, 1,4)) = 7 then dayicon=iconpath||'R'||strip(substr(cur_date, 7,2),'L','0')||'.ico' /* red ico */
else dayicon=iconpath||'N'||strip(substr(cur_date, 7,2),'L','0')||'.ico' /* normal ico */

/* create or upgrade object */
call SysCreateObject 'WPProgram',objecttext,'<WP_DESKTOP>','OBJECTID='||object_id||';EXENAME='||ScriptFile||';TITLE='||objecttext||';ICONFILE='||dayicon||';','Update'


exit


BuildCalendar:
PROCEDURE expose language weekstart
arg cur_date

 cur_d = substr(cur_date, 7,2)
 cur_m = substr(cur_date, 5,2)
 cur_y = substr(cur_date, 1,4)
 week = WeekCount(cur_y||cur_m||'01')

 total_days=TotalDaysOfMonth(cur_date)

Select
when weekstart=0 & language = "de" then string="KW   Mo  Di  Mi  Do  Fr  Sa  So"
when weekstart=1 & language = "de" then string="KW   So  Mo  Di  Mi  Do  Fr  Sa"
when weekstart=1 & language >< "de" then string="We   Su  Mo  Tu  We  Th  Fr  Sa"
otherwise string ="We   Mo  Tu  We  Th  Fr  Sa  Su"
end

string = GetMonth(cur_m) cur_y||'0d0a'x||string||'0d0a'x||right(week,2,'0')||' '

start_col = DayOfWeek('01.'||cur_m||'.'||cur_y)+weekstart

if start_col=8 then start_col=1

do i = 1 to start_col-1
string=string||'  --'
end


do day = 1 to total_days


string = string ||'  '||right(day,2,'0')

if (day + start_col-1)%7 == (day + start_col-1)/7  then do
	week = week + 1
	string = string ||'0d0a'x||right(week,2,'0')||' '
	end


/* fill last line */

if day = total_days then do until (day + start_col-1)%7 == (day + start_col-1)/7
string=string||'  --'
day = day +1
end




end


return(start_col string)




DayOfWeek: PROCEDURE
parse arg dd '.' mm '.' year

days = "7 1 2 3 4 5 6"

magic = 6 2 3 6 1 4 6 2 5 0 3 5
parse var year cent +2 yr

leap = year // 4 = 0 & (yr\=0 | cent//4=0)
dow=yr + yr%4 + (6-2*(cent//4)) + word(magic,mm) + dd
if mm < 3 & \leap then
   dow=dow+1
dow = dow // 7

return word(days,dow+1)


WeekCount: PROCEDURE expose weekstart
arg cur_date

 cur_d = substr(cur_date, 7,2)
 cur_m = substr(cur_date, 5,2)
 cur_y = substr(cur_date, 1,4)

/* count days from 1.1. to cur_date */
 DaysThisYear = cur_d

if cur_m > 1 then do i = 1 to cur_m - 1
 cur_m = right(i,2,'0')
 DaysThisYear=DaysThisYear+TotalDaysOfMonth(cur_y||cur_m||cur_d)
end

/* calculate weeks */

/* get day of 1.1. */

if weekstart = 1 then DaysOfFirstWeek = 8 - DayOfWeek("01.01."||cur_y)+6
else DaysOfFirstWeek = 8 - DayOfWeek("01.01."||cur_y)


DaysOFFollowingWeeks = DaysThisYear - DaysOfFirstWeek


if DaysOFFollowingWeeks > 0 then do
  if DaysOFFollowingWeeks / 7 == DaysOFFollowingWeeks%7 then DaysOFFollowingWeeks = DaysOFFollowingWeeks%7
  else DaysOFFollowingWeeks = DaysOFFollowingWeeks%7+1
end
else DaysOFFollowingWeeks=0


week = DaysOFFollowingWeeks
if DaysOfFirstWeek = 7 then week = week + 1


return(week)


TotalDaysOfMonth: PROCEDURE
parse arg cur_date

cur_m = substr(cur_date, 5,2)
cur_y = substr(cur_date, 1,4)


if cur_m = "01" | cur_m = "03" | cur_m = "05" | cur_m = "07" | cur_m = "08" | cur_m = "10" | cur_m = "12" then total_days = "31"
if cur_m = "04" | cur_m = "06" | cur_m = "09" | cur_m = "11" then total_days = "30"

if cur_m = "02" | cur_m = "2" then do
 if cur_y / 4 == cur_y%4 then total_days = "29"
 else total_days="28"
end

return(total_days)



GetMonth: Procedure expose language
parse arg cur_m

if language = "de" then Select
when cur_m = 1 then string =  'Januar'
when cur_m = 2 then string =  'Februar'
when cur_m = 3 then string =  'Mrz'
when cur_m = 4 then string =  'April'
when cur_m = 5 then string =  'Mai'
when cur_m = 6 then string =  'Juni'
when cur_m = 7 then string =  'Juli'
when cur_m = 8 then string =  'August'
when cur_m = 9 then string =  'September'
when cur_m = 10 then string = 'Oktober'
when cur_m = 11 then string = 'November'
when cur_m = 12 then string = 'Dezember'
otherwise string = 'Get Month ERROR'
end
else Select
when cur_m = 1 then string =  'January'
when cur_m = 2 then string =  'February'
when cur_m = 3 then string =  'March'
when cur_m = 4 then string =  'April'
when cur_m = 5 then string =  'May'
when cur_m = 6 then string =  'June'
when cur_m = 7 then string =  'July'
when cur_m = 8 then string =  'August'
when cur_m = 9 then string =  'September'
when cur_m = 10 then string = 'October'
when cur_m = 11 then string = 'November'
when cur_m = 12 then string = 'December'
otherwise string = 'Get Month ERROR'
end


return(string)





